
#delimit;
clear all;
set mem 1200m;
set more off;
capture log close;
*cd Documents/Crime/Rev5/;
*cd $filepath;
log using log\INM-R2, replace;



/*
First round of cleaning 

1. Name and label all the variables
2. Drop duplicates for admit date and release date and drop unused vars
3. Create samples for crime commit date, admit date and sample with 
	list of crimes committed.
*/

*to save hard drive space, I haven't copied this into my new directory, 
but I have copied the compressed version of this file into the same directory 
for purposes of record keeping.;
use "../Rev1/Thesis Source/INM-R2", clear;

***1. Name and label all the variables;
*rename all the variables;
rename	v1    recordkey;
rename	v1062 parguidebr1;
rename	v1063 parguidebr2;
rename	v1156 violentpersonalnumber;
rename	v1158 nonviolentpersonalnumberof;
rename	v1160 propertynumberofproperty;
rename	v1162 drugsalenumberofdrugsale;
rename	v1164 drugpossessionnumberof;
rename	v1166 alcoholnumberofalcohol;
rename	v1168 habitduinumberof;
rename	v1170 sexoffnumberofsex;
rename	v1172 othercrimenumberofother;
rename	v1174 majoroff;
rename	v127 sb441flag;
rename	v128 racecode;
rename	v13 rriorrecordkey;
rename	v130 sexcode;
rename	v131 ethnicity;
rename	v1338	crimesfromparoleguidelines;
rename	v1344	crimesfromparoleguidelines2;
rename	v1375 futureadmcode;
rename	v1377 futureoffcode;
rename	v1381 futureoffgroup;
rename	v1383 futureofftype;
rename	v1384 futurevioflag;
rename	v1385 futureparrevreason;
rename	v1387 futuredaystoreturn;
rename	v1525 gridyear;
rename	v1527 decisionnum;
rename	v1530 ageatfirstcommit;
rename	v1532 priorconvs;
rename	v1534 priorincars;
rename	v1536 successfactorfactoraage;
rename	v1537 successfactorbprio;
rename	v1538 successfactorcprior;
rename	v1539 successfactord;
rename	v1540 successfactoreheroinor;
rename	v1541 successfactorfcommitment;
rename	v1542 successfactorgfullyempl;
rename	v1543 successfactorhhadwrat;
rename	v1544 severitylevel;
rename	v1545 sucscore;
rename	v1547 sucgroup;
rename	v1548 parmonths;
rename	v1570 raterid;
rename	v1589 adjguidemos;
rename	v1592 boarddecision;
rename	v1596 totalmostoserve;
rename	v1601 guidepriorprobrevoc;
rename	v1602 guidepriorparolerevoc;
rename	v1605 rtphit006moreturned;
rename	v1606 rtphit012moreturned;
rename	v1607 rtphit018moreturned;
rename	v1608 rtphit024moreturned;
rename	v1609 rtphit030moreturned;
rename	v1610 rtphit036moreturned;
rename	v1635 parconsidtypecatii;
rename	v1639 ocdate;
rename	v1653 ocjudge;
rename	v1659 ocda;
rename	v1665 ocinmorprob;
rename	v19 recsinchain;
rename	v22 activeinmateflag;
rename	v220 topofchainflag;
rename	v221 verdictpleaflag;
rename	v23 activeparoleflag;
rename	v24 firstoffenderstatus;
rename	v26 activeprobationflag;
rename	v27 firstconvictionever;
rename	v29 uno;
rename	v319 numpriorincars;
rename	v321 homecounty;
rename	v330 employmentstatus;
rename	v341 maritalstatus;
rename	v346 educationallevel;
rename	v348 oldwratsatscore;
rename	v351 wratreadscore;
rename	v354 wratmathscore;
rename	v357 wratspelscore;
rename	v360 iqscore;
rename	v39 inmatetype;
rename	v457 cumdiscipviolent;
rename	v460 cumdiscipnonviolent;
rename	v463 cumdisciptotal;
rename	v466 probfollowmos;
rename	v471	filler02;
rename	v491 diagbehavcode1;
rename	v493 diagbehavcode2;
rename	v495 diagbehavcode3;
rename	v497 diagbehavcode4;
rename	v499 diagbehavcode5;
rename	v501 drugbehavprob;
rename	v502 alcbehavprob;
rename	v503 fambehavcode1;
rename	v505 fambehavcode2;
rename	v507 fambehavcode3;
rename	v509 fambehavcode4;
rename	v511 fambehavcode5;
rename	v528 ageatsentencing;
rename	v531 typeadmisson;
rename	v540 probationfollows;
rename	v542 probablereltype;
rename	v558 sentlengthdays;
rename	v7 topchain;
rename	v714 pardischargereason;
rename	v777 jailcreditdaysofjail;
rename	v797 jailmaxoutstatus;
rename	v800 releasecodereleasecode;
rename	v802 deathtypedeathtypecode;
rename	v804 departurecode;
rename	v805 ageatrelease;
rename	v812 servedaysprsnjailtime;
rename	v826 admneworrevnewcasever;
rename	v832 admnewprobparnewvsprob;
rename	v833 parrevreasonparole;
forvalues x = 1/10 {;
rename v836_`x' curroff`x';
};
rename	v975 reconvchkptstilhit;
rename	v977 reconvinmorprob;
rename v1356 probrevtech;
rename v1357 probrevconv;
rename v1358 probrevwoconv;
rename v1359 probrevsent;
rename v1360 probrevunknown;
rename v1361 probnewcourt;
rename v145 height;
rename v148 weight;
rename v513 mildischarge;
rename v646 mentalhealthhigh;
rename v647 mentalhealthrecent;
rename v1551 ballot;


*MAKE DATES;
gen int birthdate = mdy(v135mo,v135da,v135yr);;
gen int firstcontactdate = mdy(v1226mo,v1226da,v1226yr);
gen int crimecommitdate = mdy(v1234mo,v1234da,v1234yr);
gen int sentdate = mdy(v1258mo,v1258da,v1258yr);
gen int admitdate = mdy(v1274mo,v1274da,v1274yr);
gen int futureadmdate = mdy(v1420mo,v1420da,v1420yr);
gen int actualreldate = mdy(v1498mo,v1498da,v1498yr);
gen int dtrated = date(v1573, "YMD");


*format dates to make them easier to read;
format birthdate   
 firstcontactdate crimecommitdate sentdate 
 admitdate  futureadmdate  actualreldate dtrated %td;

label define revokereason 0"Blank";
label define revokereason 1"Waiver - Technical Violation(s)",add;
label define revokereason 3"Hearing - Technical Violation(s)",add;
label define revokereason 5"New Conviction",add;
label define revokereason 6"Waiver - Misdemeanor  (not convicted,",add;
label define revokereason 7"Waiver - Felony  (not convicted, but",add;
label define revokereason 8"Hearing - Misdemeanor (not convicted,",add;
label define revokereason 9"Hearing - Felony  (not convicted, but",add;
label define revokereason 10"New Conviction - Misdemeanor",add;
label define revokereason 11"New Conviction - Felony",add;
label values parrevreason revokereason;

label define returnreason 1 "New Conviction" 2 "Probation Revoke" 3 "Parole Revoke";
label values admnewprobpar returnreason;

label define majorcrimetype 1"Violent Personal";
label define majorcrimetype 2"Non-Violent Personal",add;
label define majorcrimetype 3"Property",add;
label define majorcrimetype 4"Drug Sales",add;
label define majorcrimetype 5"Drug Possession",add;
label define majorcrimetype 6"Alcohol",add;
label define majorcrimetype 7"Habit/DUI",add;
label define majorcrimetype 8"Sex Offense",add;
label define majorcrimetype 9"Other",add;
label values majoroff majorcrimetype;

label define depreason 0 "Active Inmate";
label define depreason 1 "Paroled with probation", add;
label define depreason 2 "Paroled without probation", add;
label define depreason 3 "Maxed out with probation", add;
label define depreason 4 "Maxed out without probation", add;
label define depreason 5 "Other release", add;
label values departurecode depreason;

label define alcbehavprob 0 "No alcohol problem";
label define alcbehavprob 1 "Alcoholic", add;
label define alcbehavprob 2 "Alcohol Abuser", add;
label values alcbehavprob alcbehavprob;

label define drugbehavprob 0 "No drug problem", add;
label define drugbehavprob 5 "Drug experimenter", add;
label define drugbehavprob 6 "Drug abuser", add;
label define drugbehavprob 7 "Narcotic addict", add;
label values drugbehavprob drugbehavprob;

label define mentalhealth 0 "No mental health eval", add;
label define mentalhealth 1 "Inmate OK", add;
label define mentalhealth 2 "Outpatient", add;
label define mentalhealth 3 "Supportive Living Unit (moderate)", add;
label define mentalhealth 4 "Supportive Living Unit (high)", add;
label define mentalhealth 5 "Crisis Stabilization", add;
label define mentalhealth 6 "In Binion Building", add;
label values mentalhealthhigh mentalhealth;
label values mentalhealthrecent mentalhealth;

label var sucscore "Success Score";
label var ageatrelease "Age at Release";
label var departure "Departure code";
label var parconsidtype "Type of Parole Considered";


***2. Drop duplicates for admit date and release date and drop unused vars;
*drop admit date;
drop if admitdate == .;
duplicates report uno admitdate;
duplicates tag uno admitdate, gen(tag);
tab dtrated if tag;
drop if tag;
drop tag;

*drop release date;
duplicates report uno actualreldate;
duplicates tag uno actualreldate if actualreldate != date("Dec 31, 9999", "MDY"), gen(tag);
sort actualreldate;
list uno crimecommitdate sentdate admitdate actualreldate curroff1 if tag == 1;
drop if tag == 1;
drop tag;

*pick variables to keep. the list below is sorted in this order:
-dates and time spent
-crime related
-parole board related
-release related
-recid and cost
-demographic;
keep 
uno sentdate admitdate   crimecommitdate firstcontactdate
 servedaysprsnj  sentlengthdays curroff* major parrevreason 
  admnewprobpar probrevconv probrevsent probnewcourt
severity* sucscore successfactor* gridyear parmonths dtrated   totalmostoserve 
boardd departure actualreldate 
reconvchkpts futureadmdate
wrat* marital priori priorc race sexc employ birthdate ageatrele cumdisciptotal 
drugbehavprob alcbehavprob mentalhealthhigh education 
violentpersonalnumber nonviolentpersonalnumberof propertynumberofproperty
drugsalenumberofdrugsale drugpossessionnumberof alcoholnumberofalcohol
 habitduinumberof sexoffnumberofsex;
 
compress;

d;

***3. Create samples for crime commit date, admit date and sample with 
	list of crimes committed.;

*released in 1987;
preserve;
keep if actualreldate >= date("Jan 1, 1987", "MDY");
save sample_rel1987, replace;
restore;

*time series figure on recidivism;
#delimit;
preserve;
keep admitdate priorincars dtrated;
save sampleUCR, replace;
restore;

*main sample (4 years back, full horizon fwd);
keep if (dtrated >= date("Apr 1, 1993", "MDY")-365*4 | dtrated == .) & 
	actualreldate >= date("Apr 1, 1993", "MDY")-365*4;
save episodes, replace;

capture log close;

