#delimit;
clear all;
set matsize 1600;
set more off;

capture log close;
log using log/reg, replace;


#delimit;
use sample_analysis, clear;


***TABLE 2***;
preserve;
local vars black female education ageatfirstcontactNum ageAtEntry priorincars 
revoc 
sucscore severitylevel sentlen
boardagree boardup  grid timeserv maxout
recid recid10 fEpisodeCount_10 fCost5_10;

foreach var in `vars' {;
gen sd`var' = `var';
};

gen count = 1;

collapse (sum) count (mean) `vars' (sd) sd*, by(after);

xpose, clear varname;

count;

gen sdBefore = v1[_n+(r(N)-1)/2];
gen sdAfter = v2[_n+(r(N)-1)/2];

rename v1 meanBefore;
rename v2 meanAfter;

drop if _n > r(N)/2+1;

outsheet using log/table2.csv, comma replace;
restore;


***TABLE 3***;
capture reg timeserv grid sentlen celld*, r cluster(cellCluster);
outreg2 using "Log/table3", excel label  replace bd(3) rd(2);
test grid = 0;
local ftest1 = r(F);

capture reg timeserv grid sentlen celld* $controls, r cluster(cellCluster);
outreg2 using "Log/table3", excel label append bd(3) rd(2) ;
test grid = 0;
local ftest2 = r(F);

preserve;
clear; 
matrix A = [`ftest1', `ftest2'];
svmat A;
outsheet using log\Table3Ftest.csv, comma replace;
restore;



***TABLE 4***;
capture reg recid timeserv celld*, r cluster(cellCluster);
outreg2 using "Log/table4", excel label  replace  bd(3) rd(2);

capture reg recid timeserv celld* $controls , r cluster(cellCluster);
outreg2 using "Log/table4", excel label  append  bd(3) rd(2); 

capture ivreg recid (timeserv = grid) celld* , r cluster(cellCluster);
outreg2 using "Log/table4", excel label  append  bd(3) rd(2); 

capture ivreg recid (timeserv = grid) celld* $controls , r cluster(cellCluster);
outreg2 using "log/table4", excel label  append  bd(3) rd(2); 

capture reg recid ageAtEntry if !after , r cluster(cellCluster);
outreg2 using "log/table4", excel label  append bd(5) rd(2); 

capture ivreg recid (timeserv = grid) departurecoded* celld* $controls , r cluster(cellCluster);
outreg2 using "log/table4", excel label  append  bd(3) rd(2); 

capture ivreg reconv (timeserv = grid) celld*  , r cluster(cellCluster);
outreg2 using "log/table4", excel label  append  bd(3) rd(2); 


***TABLE 5***;
capture ivreg fCost1_10 (timeserv = grid) celld*;  
outreg2 using "log/table5", excel label replace  bd(0) rd(3); 
forvalues x=2/5 {;
	capture ivreg fCost`x'_10 (timeserv = grid) celld* , r cluster(cellCluster); 
	outreg2 using "log/table5", excel label  append  bd(0) rd(3); 
};

preserve;
collapse fCost1_10 fCost2_10 fCost3_10 fCost4_10 fCost5_10 if !after;
outsheet using log/table5means.csv, comma replace;
restore;



***TABLE 6***;
capture ivreg fEpisodeCount_1 (timeserv = grid) celld*, r cluster(cellCluster);
outreg2 using "log/table6", excel label  replace bd(3) rd(2) noas ; 

capture ivreg fEpisodeCount_Start1  (timeserv = grid) celld*, r cluster(cellCluster);
outreg2 using "log/table6", excel label append bd(3) rd(2)  noas; 

capture ivreg fEpisodeCount_3 (timeserv = grid) celld* , r cluster(cellCluster); 
outreg2 using "log/table6", excel label  append bd(3) rd(2)  noas; 

capture ivreg fEpisodeCount_Start3  (timeserv = grid) celld* , r cluster(cellCluster);  
outreg2 using "log/table6", excel label  append bd(3) rd(2)  noas; 

capture ivreg fEpisodeCount_10 (timeserv = grid) celld* if recid10Start != . , r cluster(cellCluster); 
outreg2 using "log/table6", excel label  append bd(3) rd(2)  noas; 

capture ivreg fEpisodeCount_Start10 (timeserv = grid) celld* if recid10Start != . , r cluster(cellCluster);  
outreg2 using "log/table6", excel label  append bd(3) rd(2)  noas; 

preserve;
collapse fEpisodeCount_1 fEpisodeCount_3 fEpisodeCount_10 if !after;
outsheet using log/table6means.csv, comma replace;
restore;



***TABLE A1***;

#delimit;

#delimit;
matrix oldGrid = (18, 12, 8, 6, 4 \
				 21, 14, 9, 8, 6 \
				 24, 15, 12, 9, 8 \
				 27, 18, 15, 12, 10 \
				 52, 40, 30, 25, 20 \
				 78, 60, 54, 48, 36 \
				 102, 90, 78, 72, 60);
				 
matrix newGrid = (22, 16, 10  \
				 24, 18, 12 \
				 26, 20, 14 \
				 28, 22, 16 \
				 52, 40, 34 \
				 78, 62, 52 \
				 102, 84, 72);


use episodes_clean.dta, clear;
keep if validDates & timeLowerBound & timeUpperBound & dtrated != .;
keep if quarter >= 117 & quarter <= 148;

*quarters 117 to 132 are before change, 133 to 148 after;
tab quarter period;

reg timeserv grid;
outreg2 using "log/tableA1col1", excel label  replace  bd(3) rd(2);
outreg2 using "log/tableA1col2", excel label  replace  bd(3) rd(2);
outreg2 using "log/tableA1col3", excel label  replace  bd(3) rd(2);
outreg2 using "log/tableA1col4", excel label  replace  bd(3) rd(2);

drop firstDtrated obsIsFirstDtrated;

forvalues t = 0/6 {;
local tplus = `t'+1;

*first stage;
egen int firstDtrated = min(dtrated) if (period == `t' | period == `tplus'), by(uno);
gen byte obsIsFirstDtrated = (firstDtrated == dtrated);
gen double gridPlacebo = oldGrid[severitylevel, sucgroupBef]/12 if period == `t';
replace gridPlacebo = newGrid[severitylevel, sucgroupAft]/12 if period == `tplus';
compare grid gridPlacebo if period == `t' & obsIsFirstDtrated;
compare grid gridPlacebo if period == `tplus' & obsIsFirstDtrated;
tab gridyear period if (period == `t' | period == `tplus') & obsIsFirstDtrated;

capture reg timeserv gridPlacebo celld* 
if (period == `t' | period == `tplus') & obsIsFirstDtrated, r cluster(cellCluster);
outreg2 using "log/tableA1col1", excel label  append  bd(3) rd(2);

capture reg timeserv gridPlacebo celld* $controls
if (period == `t' | period == `tplus') & obsIsFirstDtrated, r cluster(cellCluster);
outreg2 using "log/tableA1col2", excel label  append  bd(3) rd(2);


*second stage;
gen double timeservPlacebo = timeserv;
replace timeservPlacebo = timeserv+timechange if period == `tplus';

capture ivreg recid (timeservPlacebo=gridPlacebo) celld* 
 if (period == `t' | period == `tplus') & obsIsFirstDtrated, r cluster(cellCluster);
outreg2 using "log/tableA1col3", excel label  append  bd(3) rd(2);

capture ivreg recid (timeservPlacebo=gridPlacebo) celld* $controls
 if (period == `t' | period == `tplus') & obsIsFirstDtrated, r cluster(cellCluster);
outreg2 using "log/tableA1col4", excel label  append  bd(3) rd(2);

drop timeservPlacebo firstDtrated obsIsFirstDtrated gridPlacebo;
};

*/

***TABLE A2***;

#delimit;
use sample_analysis, clear;
capture reg timeserv grid;
outreg2 using "log/tableA2", excel label  replace  bd(3) rd(2); 

foreach var in recid fEpisodeCount_ {;
foreach t of numlist 1 3 10 {;
capture ivreg `var'`t' (timeserv = grid) celld*, r cluster(cellCluster);
outreg2 using "log/tableA2", excel label  append  bd(3) rd(2); 
};
};

foreach t of numlist 1 3 10 {;
capture ivreg fCost5_`t' (timeserv = grid) celld*, r cluster(cellCluster);
outreg2 using "log/tableA2", excel label  append  bd(0) rd(2); 
};

capture log close;
